Up

# NSEvent

### Authors

Scott Christley (`scottc@net-community.com`)
Ovidiu Predescu (`ovidiu@net-community.com`)
Felipe A. Rodriguez (`far@ix.netcom.com`)

> The event class

Copyright: (C) 1996 Free Software Foundation, Inc.

# Software documentation for the NSEvent class

## NSEvent : NSObject

> Declared in:
>   AppKit/NSEvent.h

> Conforms to:
>   NSCoding
>   NSCopying

Availability: OpenStep
Description forthcoming.

Instance Variables
Method summary

- +enterExitEventWithType:location:modifierFlags:timestamp:windowNumber:context:eventNumber:trackingNumber:userData:
- +keyEventWithType:location:modifierFlags:timestamp:windowNumber:context:characters:charactersIgnoringModifiers:isARepeat:keyCode:
- +mouseEventWithType:location:modifierFlags:timestamp:windowNumber:context:eventNumber:clickCount:pressure:
- +mouseEventWithType:location:modifierFlags:timestamp:windowNumber:context:eventNumber:clickCount:pressure:buttonNumber:deltaX:deltaY:deltaZ:
- +mouseLocation
- +otherEventWithType:location:modifierFlags:timestamp:windowNumber:context:subtype:data1:data2:
- +startPeriodicEventsAfterDelay:withPeriod:
- +stopPeriodicEvents
- -absoluteX
- -absoluteY
- -absoluteZ
- -buttonMask
- -buttonNumber
- -capabilityMask
- -characters
- -charactersIgnoringModifiers
- -clickCount
- -context
- -data1
- -data2
- -deltaX
- -deltaY
- -deltaZ
- -deviceID
- -eventNumber
- -isARepeat
- -isEnteringProximity
- -keyCode
- -locationInWindow
- -modifierFlags
- -pointingDeviceID
- -pointingDeviceSerialNumber
- -pointingDeviceType
- -pressure
- -rotation
- -subtype
- -systemTabletID
- -tabletID
- -tangentialPressure
- -tilt
- -timestamp
- -trackingNumber
- -type
- -uniqueID
- -userData
- -vendorDefined
- -vendorID
- -vendorPointingDeviceType
- -window
- -windowNumber

### enterExitEventWithType: location: modifierFlags: timestamp: windowNumber: context: eventNumber: trackingNumber: userData:

+ (NSEvent*) enterExitEventWithType: (NSEventType)type location: (NSPoint)location modifierFlags: (unsigned int)flags timestamp: (NSTimeInterval)time windowNumber: (int)windowNum context: (NSGraphicsContext*)context eventNumber: (int)eventNum trackingNumber: (int)trackingNum userData: (void*)userData;
Availability: OpenStep
Description forthcoming.

### keyEventWithType: location: modifierFlags: timestamp: windowNumber: context: characters: charactersIgnoringModifiers: isARepeat: keyCode:

+ (NSEvent*) keyEventWithType: (NSEventType)type location: (NSPoint)location modifierFlags: (unsigned int)flags timestamp: (NSTimeInterval)time windowNumber: (int)windowNum context: (NSGraphicsContext*)context characters: (NSString*)keys charactersIgnoringModifiers: (NSString*)ukeys isARepeat: (BOOL)repeatKey keyCode: (unsigned short)code;
Availability: OpenStep
Description forthcoming.

### mouseEventWithType: location: modifierFlags: timestamp: windowNumber: context: eventNumber: clickCount: pressure:

+ (NSEvent*) mouseEventWithType: (NSEventType)type location: (NSPoint)location modifierFlags: (unsigned int)flags timestamp: (NSTimeInterval)time windowNumber: (int)windowNum context: (NSGraphicsContext*)context eventNumber: (int)eventNum clickCount: (int)clickNum pressure: (float)pressureValue;
Availability: OpenStep
Description forthcoming.

### mouseEventWithType: location: modifierFlags: timestamp: windowNumber: context: eventNumber: clickCount: pressure: buttonNumber: deltaX: deltaY: deltaZ:

+ (NSEvent*) mouseEventWithType: (NSEventType)type location: (NSPoint)location modifierFlags: (unsigned int)flags timestamp: (NSTimeInterval)time windowNumber: (int)windowNum context: (NSGraphicsContext*)context eventNumber: (int)eventNum clickCount: (int)clickNum pressure: (float)pressureValue buttonNumber: (int)buttonNum deltaX: (float)deltaX deltaY: (float)deltaY deltaZ: (float)deltaZ;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### mouseLocation

+ (NSPoint) mouseLocation;
Availability: OpenStep
Returns the current mouse location.

### otherEventWithType: location: modifierFlags: timestamp: windowNumber: context: subtype: data1: data2:

+ (NSEvent*) otherEventWithType: (NSEventType)type location: (NSPoint)location modifierFlags: (unsigned int)flags timestamp: (NSTimeInterval)time windowNumber: (int)windowNum context: (NSGraphicsContext*)context subtype: (short)subType data1: (int)data1 data2: (int)data2;
Availability: OpenStep
Description forthcoming.

### startPeriodicEventsAfterDelay: withPeriod:

+ (void) startPeriodicEventsAfterDelay: (NSTimeInterval)delaySeconds withPeriod: (NSTimeInterval)periodSeconds;
Availability: OpenStep
Description forthcoming.

### stopPeriodicEvents

+ (void) stopPeriodicEvents;
Availability: OpenStep
Description forthcoming.

### absoluteX

- (int) absoluteX;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### absoluteY

- (int) absoluteY;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### absoluteZ

- (int) absoluteZ;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### buttonMask

- (unsigned int) buttonMask;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### buttonNumber

- (int) buttonNumber;
Availability: MacOS-X 10.0.0
Returns the button number for the mouse button pressed in a mouse event. Intended primarily for the case where a mouse has three or more buttons, and you want to know which button an 'other' mouse event refers to.

### capabilityMask

- (unsigned int) capabilityMask;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### characters

- (NSString*) characters;
Availability: OpenStep
Returns the string of characters for a keyboard event.
Raises an NSInternalInconsistencyException if applied to any other type of event.

### charactersIgnoringModifiers

- (NSString*) charactersIgnoringModifiers;
Availability: OpenStep
Returns the string of characters for a keyboard event, as if no modifier keys had been pressed when the keyboard event occirred.
Raises an NSInternalInconsistencyException if applied to any other type of event.

### clickCount

- (int) clickCount;
Availability: OpenStep
Return the number of clicks associated with the mouse down or up event. This method is not applicable for any event type other than a mouse down or mouse up.
Raises an NSInternalInconsistencyException if applied to any other type of event.

### context

- (NSGraphicsContext*) context;
Availability: OpenStep
Returns the graphics context for which this event was generated.

### data1

- (int) data1;
Availability: OpenStep
Returns the 'data1' item associated with the event.
Raises NSInternalInconsistencyException if the event is not of type NSAppKitDefined, NSSystemDefined, NSApplicationDefined, or NSPeriodic

### data2

- (int) data2;
Availability: OpenStep
Returns the 'data2' item associated with the event.
Raises NSInternalInconsistencyException if the event is not of type NSAppKitDefined, NSSystemDefined, NSApplicationDefined, or NSPeriodic

### deltaX

- (float) deltaX;
Availability: MacOS-X 10.0.0

Returns the movement of the mouse on the X axis.

This method is only valid for NSMouseMoved, NS*MouseDragged and NSScrollWheel events, otherwise it will raise an NSInternalInconsistencyException.

### deltaY

- (float) deltaY;
Availability: MacOS-X 10.0.0

Returns the movement of the mouse on the Y axis.

This method is only valid for NSMouseMoved, NS*MouseDragged and NSScrollWheel events, otherwise it will raise an NSInternalInconsistencyException.

### deltaZ

- (float) deltaZ;
Availability: MacOS-X 10.0.0

Returns the movement of the mouse on the Z axis.

This method is only valid for NSMouseMoved, NS*MouseDragged and NSScrollWheel events, otherwise it will raise an NSInternalInconsistencyException.

The value returned is 0.0 in most cases.

### deviceID

- (unsigned int) deviceID;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### eventNumber

- (int) eventNumber;
Availability: OpenStep
Returns the event number associated with any mouse event or tracking event. Event numbers are allocated sequentially when the system creates these events.
Raises an NSInternalInconsistencyException if applied to any other type of event.

### isARepeat

- (BOOL) isARepeat;
Availability: OpenStep
Returns a flag to say if this is a keyboard repeat event.
Raises an NSInternalInconsistencyException if applied to any other type of event than an NSKeyUp or NSKeyDown.

### isEnteringProximity

- (BOOL) isEnteringProximity;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### keyCode

- (unsigned short) keyCode;
Availability: OpenStep
Returns the numeric key code of a keyboard event.
Raises an NSInternalInconsistencyException if applied to any other type of event than an NSKeyUp or NSKeyDown.

### locationInWindow

- (NSPoint) locationInWindow;
Availability: OpenStep
Returns the window location for which this event was generated (in the base coordinate system of the window).

### modifierFlags

- (unsigned int) modifierFlags;
Availability: OpenStep
Returns the modifier flag bits associated with the event.

### pointingDeviceID

- (unsigned int) pointingDeviceID;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### pointingDeviceSerialNumber

- (unsigned int) pointingDeviceSerialNumber;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### pointingDeviceType

- (NSPointingDeviceType) pointingDeviceType;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### pressure

- (float) pressure;
Availability: OpenStep
Returns the pressure associated with a mouse event. This is a value in the range 0.0 to 1.0 and for mormal mouse events should be set to one of those extremes. This is used by pressure sensitive input devices.
Raises an NSInternalInconsistencyException if applied to any other type of event than a mouse event.

### rotation

- (float) rotation;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### subtype

- (short) subtype;
Availability: OpenStep
Returns the 'subtype' item associated with the event.
Raises NSInternalInconsistencyException if the event is not of type NSAppKitDefined, NSSystemDefined, NSApplicationDefined, NSPeriodic or a mouve event.

### systemTabletID

- (unsigned int) systemTabletID;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### tabletID

- (unsigned int) tabletID;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### tangentialPressure

- (float) tangentialPressure;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### tilt

- (NSPoint) tilt;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### timestamp

- (NSTimeInterval) timestamp;
Availability: OpenStep
Returns the time interval since system startup at which this event was generated.

### trackingNumber

- (int) trackingNumber;
Availability: OpenStep
Returns a number identifying the tracking rectangle entered or exited.
Raises an NSInternalInconsistencyException if applied to any other type of event than a mouse entered or exited event.

### type

- (NSEventType) type;
Availability: OpenStep
returns the type of this event.

### uniqueID

- (unsigned long long) uniqueID;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### userData

- (void*) userData;
Availability: OpenStep
Returns usder data associated with a tracking event... the data assigned to the tracking rectangle concerned when it was created..
Raises an NSInternalInconsistencyException if applied to any other type of event than a mouse entered or exited event.

### vendorDefined

- (id) vendorDefined;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### vendorID

- (unsigned int) vendorID;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### vendorPointingDeviceType

- (unsigned int) vendorPointingDeviceType;
Availability: Not in OpenStep/MacOS-X
Description forthcoming.

### window

- (NSWindow*) window;
Availability: OpenStep
Returns the window for which this event was generated.
Periodic events have no associated window, and you should not call this method for those events.

### windowNumber

- (int) windowNumber;
Availability: OpenStep
Returns the window number of the window for which this event was generated.
Periodic events have no associated window, and you should not call this method for those events.

## Instance Variables for NSEvent Class

### event_context

@protected NSGraphicsContext* event_context;
Availability: OpenStep
Description forthcoming.

### event_data

@protected union _MB_event_data event_data;
Availability: OpenStep
Description forthcoming.

### event_time

@protected NSTimeInterval event_time;
Availability: OpenStep
Description forthcoming.

### event_type

@protected NSEventType event_type;
Availability: OpenStep
Description forthcoming.

### location_point

@protected NSPoint location_point;
Availability: OpenStep
Description forthcoming.

### modifier_flags

@protected unsigned int modifier_flags;
Availability: OpenStep
Description forthcoming.

### window_num

@protected int window_num;
Availability: OpenStep
Description forthcoming.

Up